﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace TreeViewExample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.treeView1.ItemsSource = this.GenerateTreeViewData();
        }

        private ObservableCollection<object> GenerateTreeViewData()
        {
            ObservableCollection<object> collection = new ObservableCollection<object>();
            for (int i = 0; i < 5; i++)
            {
                string name1 = string.Format("Item {0}", i);
                DataItem d1 = new DataItem();
                d1.Name = name1;

                for (int j = 0; j < 5; j++)
                {
                    string name2 = string.Format("Item {0}.{1}", i, j);
                    DataItem d2 = new DataItem();
                    d2.Name = name2;
                    d1.Children.Add(d2);
                }
                collection.Add(d1);
            }
            return collection;
        }

        private void TextBlock_MouseEnter(object sender, MouseEventArgs e)
        {
            TextBlock item = sender as TextBlock;
            if (Keyboard.Modifiers == ModifierKeys.Control)
            {
                item.TextDecorations = TextDecorations.Underline;
            }
        }

        private void TextBlock_MouseLeave(object sender, MouseEventArgs e)
        {
            TextBlock item = sender as TextBlock;
            item.TextDecorations = null;
        }
    }

    public class DataItem
    {
        public DataItem()
        {
            this.Children = new ObservableCollection<DataItem>();
        }
        public string Name { get; set; }
        public ObservableCollection<DataItem> Children { get; set; }
    }
}
